# Class with generic code for composers
from qgis.core import QgsProject, QgsComposition
from PyQt5.QtXml import QDomDocument
import os.path


def load_from_template(
        plugin_template_filename, # dans repertoire PAGGF/composer
        substitution_map=dict()
    ):
        global composition

        template_path = os.path.join(
            os.path.dirname(__file__), plugin_template_filename)

        template_content = None
        with open(template_path, encoding="utf-8") as template_file:
            template_content = template_file.read()
        template_file.close()

        template_qdoc = QDomDocument()
        template_qdoc.setContent(template_content)

        composition = QgsComposition(QgsProject.instance())

        composition.loadFromTemplate(
            template_qdoc,
            substitution_map)

        return composition
