from qgis.core import QgsExpressionContextUtils, QgsProject
import os.path


class PAGGFUtils(object):
    def __init__(self, paggf_layers):
        self.layers = paggf_layers  # instance de LoadedLayers
        self.plugin_dir = os.path.dirname(__file__)

    def get_municipality(self, municipality_id):
        return self.layers.get_feature(
            "ref", "municipalities", municipality_id)

    def get_province_by_munip_id(self, municipality_id):
        municipality = self.get_municipality(municipality_id)
        if municipality:
            return self.layers.get_feature(
                "ref", "provinces", municipality['id_province'])

    def get_current_municipality_id(self):
        project = QgsProject.instance()
        return QgsExpressionContextUtils.projectScope(project).variable(
            'id_municipality')

    def get_current_municipality(self):
        municipality_id = self.get_current_municipality_id()
        if municipality_id:
            return self.get_municipality(municipality_id)

    def get_current_province(self):
        municipality = self.get_current_municipality()
        if municipality:
            return self.get_province_by_munip_id(municipality['id'])

    def get_current_parcels_for(self, municipality):
        return self.layers.get_features_by_cond(
            'gis', 'current_idc_parcels', #TOOD idc_parcels
            (lambda f: f['id_sub_hill_avenue'][:4] == municipality['id'])
        )
